#ifndef LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the debugger library include file.
 *
 * This file may be copied and/or distributed at free will.
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer
//


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 Standard library integration 
//

// Initially assume autodetection mode
#define LIB_MQLAPI_TRACE_STDLIB_AUTODETECT


// Selective inclusion of CObject dependencies
#ifdef LIB_MQL_STDLIB_USING_CCHART
    #define LIB_MQLAPI_TRACE_STDLIB_CCHART
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_CCHARTOBJECT
    #define LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_CFILE
    #define LIB_MQLAPI_TRACE_STDLIB_CFILE
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_C_DOHP_INFO
    #define LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_CSYMBOLINFO
    #define LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_CTRADE
    #define LIB_MQLAPI_TRACE_STDLIB_CTRADE
    #ifndef LIB_MQL_STDLIB_USING_COBJECT
        #define LIB_MQL_STDLIB_USING_COBJECT

    #endif

#endif
#ifdef LIB_MQL_STDLIB_USING_COBJECT
    #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_COBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_COBJECT

    #endif
    #undef LIB_MQL_STDLIB_USING_COBJECT

#endif


// Full include of CObject + dependencies
#ifdef LIB_MQL_STDLIB_USING_COBJECT
    #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCHART
        #define LIB_MQLAPI_TRACE_STDLIB_CCHART

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CFILE
        #define LIB_MQLAPI_TRACE_STDLIB_CFILE

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
        #define LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
        #define LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CTRADE
        #define LIB_MQLAPI_TRACE_STDLIB_CTRADE

    #endif

#endif

// Include CExpertBase
#ifdef LIB_MQL_STDLIB_USING_CEXPERT_BASE
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
        #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
        #define LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CEXPERT_BASE

    #endif

#endif

// Include CSeries
#ifdef LIB_MQL_STDLIB_USING_CSERIES
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CSERIES
        #define LIB_MQLAPI_TRACE_STDLIB_CSERIES
        #define LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CSERIES

    #endif

#endif

// Include CCanvas
#ifdef LIB_MQL_STDLIB_USING_CCANVAS
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
        #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS
        #define LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CCANVAS

    #endif

#endif



// General full include
#ifdef LIB_DEBUG_USING_MQL_STDLIB
    #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCHART
        #define LIB_MQLAPI_TRACE_STDLIB_CCHART

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CFILE
        #define LIB_MQLAPI_TRACE_STDLIB_CFILE

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
        #define LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
        #define LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CTRADE
        #define LIB_MQLAPI_TRACE_STDLIB_CTRADE

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
        #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CSERIES
        #define LIB_MQLAPI_TRACE_STDLIB_CSERIES

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
        #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

    #endif
    #undef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT

#endif

//
/////////////////////////////////////////////////////////////////////////////////////////////////////





/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 Standard library autodetect 
//
#ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT
    #ifndef LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_COBJECT
        #ifndef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_COBJECT
            #define LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_COBJECT

        #endif

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CEXPERT_BASE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CEXPERT_BASE

        #endif

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CSERIES
        #ifndef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CSERIES
            #define LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CSERIES

        #endif

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_NO_AUTODETECT_CCANVAS
        #ifndef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CCANVAS

        #endif

    #endif
    #undef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT

#endif


// Detect CObject
#ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_COBJECT
    #ifdef ERR_USER_INVALID_HANDLE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
            #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

        #endif
        
    #endif
    #ifdef ERR_USER_INVALID_BUFF_NUM
        #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
            #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

        #endif
        
    #endif
    #ifdef ERR_USER_ITEM_NOT_FOUND
        #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
            #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

        #endif
        
    #endif
    #ifdef ERR_USER_ARRAY_IS_EMPTY
        #ifndef LIB_MQLAPI_TRACE_STDLIB_COBJECT
            #define LIB_MQLAPI_TRACE_STDLIB_COBJECT

        #endif
        
    #endif

#endif


// Detect CExpertBase
#ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CEXPERT_BASE
    #ifdef IS_OPEN_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_HIGH_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_LOW_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_CLOSE_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_SPREAD_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_TIME_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_TICK_VOLUME_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif
    #ifdef IS_REAL_VOLUME_SERIES_USAGE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #define LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE

        #endif
        
    #endif

#endif


// Detect CSeries
#ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CSERIES
    #ifdef DEFAULT_BUFFER_SIZE
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CSERIES
            #define LIB_MQLAPI_TRACE_STDLIB_CSERIES

        #endif
        
    #endif

#endif


// Detect CCanvas
#ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_CCANVAS
    #ifdef XRGB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef ARGB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef TRGB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef GETRGB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef GETRGBA
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef GETRGBR
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef GETRGBG
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef GETRGBB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef COLOR2RGB
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif
    #ifdef RGB2COLOR
        #ifndef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #define LIB_MQLAPI_TRACE_STDLIB_CCANVAS

        #endif
        
    #endif

#endif
//
/////////////////////////////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Include standard library
//

// Include standard library based on CObject
#ifdef LIB_MQLAPI_TRACE_STDLIB_COBJECT
    #ifdef LIB_MQLAPI_TRACE_STDLIB_AUTODETECT_COBJECT
        #include <Object.mqh>
        #include <Charts/Chart.mqh>
        #include <ChartObjects/ChartObjectSubChart.mqh>
        #include <Files/File.mqh>
        #include <Trade/DealInfo.mqh>
        #include <Trade/OrderInfo.mqh>
        #include <Trade/HistoryOrderInfo.mqh>
        #include <Trade/PositionInfo.mqh>
        #include <Trade/SymbolInfo.mqh>
        #include <Trade/Trade.mqh>

        #define LIB_MQLAPI_TRACE_STDLIB_CCHART
        #define LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
        #define LIB_MQLAPI_TRACE_STDLIB_CFILE
        #define LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
        #define LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
        #define LIB_MQLAPI_TRACE_STDLIB_CTRADE

    #else
        #ifdef LIB_MQLAPI_TRACE_STDLIB_COBJECT
            #include <Object.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CCHART
            #include <Charts/Chart.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CCHARTOBJECT
            #include <ChartObjects/ChartObjectSubChart.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CFILE
            #include <Files/File.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_C_DOHP_INFO
            #include <Trade/DealInfo.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CSYMBOLINFO
            #include <Trade/OrderInfo.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CTRADE
            #include <Trade/HistoryOrderInfo.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
            #include <Trade/PositionInfo.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CSERIES
            #include <Trade/SymbolInfo.mqh>

        #endif
        #ifdef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
            #include <Trade/Trade.mqh>

        #endif

    #endif
    #ifndef LIB_MQLAPI_TRACE_STDLIB_EXTENSION
        #define LIB_MQLAPI_TRACE_STDLIB_EXTENSION

    #endif

#endif

// Include standard library based on CExpertBase
#ifdef LIB_MQLAPI_TRACE_STDLIB_CEXPERT_BASE
    #include <Expert/Trailing/TrailingMA.mqh>
    #ifndef LIB_MQLAPI_TRACE_STDLIB_EXTENSION
        #define LIB_MQLAPI_TRACE_STDLIB_EXTENSION

    #endif

#endif

// Include standard library CSeries
#ifdef LIB_MQLAPI_TRACE_STDLIB_CSERIES
    #include <Indicators/Series.mqh>
    #ifndef LIB_MQLAPI_TRACE_STDLIB_EXTENSION
        #define LIB_MQLAPI_TRACE_STDLIB_EXTENSION

    #endif

#endif

// Include standard library CCanvas
#ifdef LIB_MQLAPI_TRACE_STDLIB_CCANVAS
    #include <Canvas/Canvas.mqh>
    #ifndef LIB_MQLAPI_TRACE_STDLIB_EXTENSION
        #define LIB_MQLAPI_TRACE_STDLIB_EXTENSION

    #endif

#endif 

// Include standard librarrry MathXXX functions
#ifdef LIB_MQL_STDLIB_USING__STATS_MATH
    #include <Math/Stat/Math.mqh>

#endif
//
/////////////////////////////////////////////////////////////////////////////////////////////////////



//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_INJECTOR_MQL5_TRACER_MQH_INCLUDED
